/*
      The view for a single todo note
      (created and appended to <tbody id="todo-list"> by appView.js)

*/

define([
    'jquery', 'underscore', 'backbone', 'mustache', 'text!templates/todoNote.html'
    //'text!templates/todoNote.html'
], function($, _, Backbone, Mustache, todoNoteTemplate) {
    'use strict';

    var TodoNoteView = Backbone.View.extend({

        tagName: 'tr', // Will wrap template in an <tr> element
        template: Mustache.parse(todoNoteTemplate),

        // Incomming events from GUI
        events: {
            // TODO
        },

        initialize: function(todoNote) {
            // TODO
        },

        // Will create a HTML table row
        render: function() {
            var m = Mustache.render(todoNoteTemplate, {"note": this.todoNote.attributes});
            this.$el.append(m); //.html(m);

        },
        delete: function(e) {
           // TODO
        },
        edit: function() {
           // TODO
        },
        update: function(e) {
            var input = this.$('.edit');
            if (e.which !== 13 || !input.val().trim()) {
                return;
            }
            var input = this.$('.edit');
            input.attr("disabled", "disabled");
            this.todoNote.set({text: input.val()});
        },
        spy: function(e) {
            console.log(JSON.stringify(e));
        }
    });

    return TodoNoteView;
});
