/*

    Asynchronous programming

    To run
    $ node app.js

*/

var fs = require('fs');

// Synchronous, strict ordered outputs
/*var f1 = fs.readFileSync("f1.txt", "utf-8");
console.log("f1");
var f2 = fs.readFileSync("f2.txt", "utf-8");
console.log("f2");
var f3 = fs.readFileSync("f3.txt", "utf-8");
console.log("f3");
console.log("-----------------------------");
*/
// Output in any order
/*fs.readFile("f1.txt", function(err, data) {
    console.log("f1");
});
fs.readFile("f2.txt", function(err, data) {
    console.log("f2");
});
fs.readFile("f3.txt", function(err, data) {
    console.log("f3");
});*/
console.log("-----------------------------");

// Output strictly ordered but
// **callback hell** (pyramid of doom)
/*fs.readFile('f1.txt', function(err, data) {
    console.log("f1");
    fs.readFile("f2.txt", function(err, data) {
        console.log("f2")
        fs.readFile("f3.txt", function(err, data) {
            console.log("f3");
        })
    })
});*/

console.log("-----------------------------");

/*
  Using Promises
*/
var fsp = require('fs-promise');
fsp.readFile("f1.txt").then(function(err, data) {
    console.log("f1");
    return fsp.readFile("f2.txt")
}).catch(function(err) { // Optional
    console.log(err);
}).then(function(err, data) {
    console.log("f2");
    return fsp.readFile("f3.txt");
}).then(function(err, data) {
    console.log("f3");
});
