/*
 *  Basic JavaScript
 *  (this is a multi line comment)
 *
 *
 */
'use strict'; // Fewer unsafe features, more warnings, and more logical behavior.

// Semicolons optional, but USE!
// Literals and types (array literals,
// see below) ---------------
console.log(true); // .. and false: Booleans
console.log(1.45); // Numbers (no integers all are 64 bit floating point)
console.log('Hello again'); // Strings: or " "

// Variables and assignments ---------------------------------------
var x; // Varible declaration. NO type!
console.log(x); // Initial value?

x = 55; // Assignment
x = x + 1;
x += 1;

var ε; // Variable names
var строка;
var _tmp;
var $foo2;

// Conversion Numbers and Booleans
var n1 = Number("123"); // String -> Number
var n2 = parseInt("123");
var b = Boolean("true"); // String -> Boolean

// Operators
// --------------------------------------
// ------------ Aritmetical
console.log(x + 1);
console.log(x - 1);
console.log(2 * x);
console.log(2 / x); // NO Integers!
console.log(2 % x);

// Inc dec
x++;
x--;

// Logical and comparison Booleans,
// Numbers, Strings, null and undefined
// are primitive types So compare by
// value (primitives are immutable)
console.log(null == undefined); // Mixed type equals. NEVER USE!
console.log(true == 2 || false == 2);
console.log(true == '1' && true == '2');
console.log(123 == '123');
console.log(123 != '123');

console.log(null === undefined); // Same type equals USE!
console.log(123 === '123');
console.log(123 !== '123');

// More on Strings (coersion see below)
// ----------------------
console.log("abcdef");
console.log("abc" > "Abc");
var str = String(123); // Number -> String
'abc'.charAt(1); // Strings are primitives, see Wrapper objects below
'abc'.length; // Property
'abc'.split(''); // To String array , see below
'abc'.slice(2);
'abc'.trim();
'abc'.concat("123", "xsr", "000");
'abc'.toLowerCase();
'abc'.toUpperCase();
'abc'.indexOf("b");
'abc'.lastIndexOf("b");

// ----- Math ---------------
Math.random();
Math.ceil(4.5);
Math.floor(4.5);
Math.round(4.62);
Math.sqrt(9);
Math.pow(2, 4);
Math.max(1, 4, 6, 72, 3);

// Control flow --------------------------
var y = 45;
if (y >= 0) {
    x = y;
} else {
    x = -y;
}

var a;
if (!a) { // Standard check for valid value
    // a is one of the "falsy": undefined, null "", 0, NaN, or false
}

// Standard initialization if z falsy
// use 1
var z;
var init = z || 1;

var fruit = 'apple';
switch (fruit) {
    case 'banana':
        // ...
        break;
    case 'apple': // Any expression compared using ===
        // ...
        break;
    default: // all other cases
        // ...
}

while (x > 0) {
    x--;
}

for (var i = 0; i < 3; i++) {
    console.log(i);
}

// Arrays --------------------------------------
// Arrays are objects
var arr = ['x', 'b', 'c']; // Array literal
var arr2 = arr; // Alias
console.log(arr);
console.log(arr.length);
console.log(arr[1]); // Get
arr[0] = 'a'; // Set

var arr3 = new Array(2); // Also possible
console.log(arr3[1]);

// Arrays are like dynamic maps
var hole = [];
hole[0] = 'a';
hole[2] = 'b'; // [ 'a', , 'b' ]

// Traversing (also see below functional style)
for (var i = 0; i < hole.length; i++) { // Test: arr.lenght !!!
    console.log(hole[i]);
}

// Destructive manipulation
var fst = arr.shift(); // Remove first, mover others one step
arr.unshift(0, 1); // Prepend, Hmm types ...
var last = arr.pop(); // Remove last
arr.push(true); // Append
arr.splice(2, 1); // Remove from 2
arr.reverse();
arr.sort();
arr.length = 0; // Clear

// Functional style (functions upcoming ... )
['a',, 'b'].forEach(function(x, i) { // Will skip holes
    console.log(i + '.' + x);
});
['a',, 'b'].map(function(x, i) { // Skip holes but preserves
    return i + '.' + x;
});
['a',, 'b'].filter(function(x) { // Eliminates holes
    return true;
});
['a',, 'b'].join('-'); // Converts holes, undef, and null to "";

// Array pitfalls
var myArray = [];
console.log(myArray.length); // 0
myArray[100] = 'some value';
console.log(myArray.length); // 101 despite containing one element

var myarray = [
    80,
    9,
    34,
    23,
    5,
    1
];
myarray.sort();
console.log(myarray); // Default is lexicographical i.e. [1, 23, 34, 5, 80, 9]

// Wrapper objects for primitives ---------------------------------------------
// As soon as accessing property or method JS will wrap primitive to
// corresponding object (as seen with string above)
console.log(123.0.valueOf()); // Wrap to Number, call method
console.log("12345".length); // Wrapt to String

// Pitfalls
var objectStr = new String("foo"); // Explicit create wrapper
objectStr.bar = 2; // Possible to dynamically add properties (attributes)
console.log(objectStr.bar); // 2, Ok!

var primitiveStr = "foo"; // Primitive value
// 'Use strict' will mark this as an
// error primitiveStr.bar = 2;        //
// Will automtically wrap and add
// attribute and *finally dispose*!
console.log(primitiveStr.bar); // Undefined, object gone, and primitve can't have attributes
