package mvc.model;

import java.util.ArrayList;
import java.util.List;

/**
 * Singleton to access the model
 * (normally JEE uses injection, see CDI later)
 * 
 * @author hajo
 */
public enum Model {
    INSTANCE;
    
    private final List<Person> persons = new ArrayList<>();
    
    private Model(){
        persons.add(new Person(1, "olle"));
        persons.add(new Person(2, "pelle"));
        persons.add(new Person(3, "fia"));
    }
   
    public List<Person> getPersons() {
        return persons;
    }

     public Person getById(int i) {
         for( Person p : persons){
             if( p.getId() == i){
                 return p;
             }
         }
        return null;
    }
}
