package session.control;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import session.beans.SessionData;

/**
 * Standard front controller
 *
 * @author hajo
 */
@WebServlet(name = "SessionServlet", urlPatterns = {"/servlet"})
public class SessionServlet extends HttpServlet {

    private static final Logger LOG = Logger.getLogger(SessionServlet.class.getName());

    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        
        LOG.log(Level.INFO, request.getSession().getId());

        String name = request.getParameter("name");
        // Normally contact database or other here.
        if( name.equals("otto")){
            // Get HttpSessionObject
            request.getSession().setAttribute("user", name);
            response.sendRedirect("home.jsp");
        }else{
            // Bit bad: Spelling errors, modification problems
            SessionData msg = (SessionData) request.getSession().getAttribute("sessionData");
            msg.setLoginMessage("Login failed");
            response.sendRedirect("index.jsp");
        }
    }

}
