<%@page contentType="text/html;charset=UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<!--
     
    The master view of the list (i.e. list all items but not full content of each)
        
    - Use beans to supply data to page
    - Use standard HTML and JSTL tags to create a table of items (from bean) 
    - Add links to detail page (for each item)
    - Include header and footer.
    
-->
<!DOCTYPE html>
<html>
    <head>
        <title>JSP Templating</title>
        <link rel="stylesheet" href="css/default.css"/>
    </head>
    <body>
        <jsp:include page="/partials/header.jsp"/>
        <!-- Possible scopes for beans: page, request, session, application -->
        <jsp:useBean id="bean" scope="application" class="jsp.view.ViewModel"/>
        <div class="pageContent">
            <h1>Master</h1>
            <!--  This is the master page with a list of entities -->
            <table>
                <c:forEach var= "person" items="${bean.persons}" >
                    <tr>
                        <td>
                            <a href="details.jsp?id=${person.id}">${person.id}</a>
                        </td>
                        <td>
                            ${person.name}
                        </td>
                    </tr>
                </c:forEach>
            </table>
        </div>
        <jsp:include page="/partials/footer.jsp"/>
    </body>
</html>


