package jdbc.control;

import jdbc.db.PersonDAO;
import java.io.IOException;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import jdbc.db.Database;

/**
 * Servlet using a DAO Service
 *
 * @author hajo
 */
@WebServlet(name = "FC", urlPatterns = {"/fc"})
public class FrontController extends HttpServlet {

    private static final Logger LOG = Logger.getAnonymousLogger();
    private static final Level I = Level.INFO;
    
    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {

        req.setCharacterEncoding("UTF-8");
        String action = req.getParameter("action");

        switch (action) {
            case "add":
                add(req, resp);
                break;
            case "delete":
                delete(req, resp);
                break;
            default: ;
        }
    }

    private void add(HttpServletRequest req, HttpServletResponse resp)
            throws IOException {
        PersonDAO dao = Database.INSTANCE.get();

        String name = req.getParameter("name");
        LOG.log(I, "Adding " + name);
        try {
            dao.add(name);
        } catch (SQLException ex) {
            LOG.log(I, "Database fail {0}", ex.getMessage());
        }
        // PRG because this is a POST
        resp.sendRedirect("list.jsp");
    }

    private void delete(HttpServletRequest req, HttpServletResponse resp) throws IOException {
        PersonDAO dao = Database.INSTANCE.get();

        String id = req.getParameter("id");
        try {
            dao.delete(Long.valueOf(id));
        } catch (SQLException ex) {
            LOG.log(I, "Database fail " + ex.getMessage());
        }
        // PRG because this is a POST
        resp.sendRedirect("list.jsp");
    }

}
