package orm.control;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import orm.db.Database;
import orm.dao.PersonDAO;
import orm.model.Person;

/**
 * Servlet using a DAO Service
 *
 * @author hajo
 */
@WebServlet(name = "FrontController", urlPatterns = {"/fc"})
public class FrontController extends HttpServlet {

    private static final Logger LOG = Logger.getAnonymousLogger();

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {

        req.setCharacterEncoding("UTF-8");
        String action = req.getParameter("action");

        switch (action) {
            case "add":
                add(req, resp);
                break;
            case "delete":
                delete(req, resp);
                break;
            default: ;
        }
    }

    private void add(HttpServletRequest req, HttpServletResponse resp)
            throws IOException {

        String id = req.getParameter("id");
        String name = req.getParameter("name");
        LOG.log(Level.INFO, "Adding {0} {1}", new Object[]{id, name});

        PersonDAO dao = Database.INSTANCE.getPersonDAO();
        dao.add(new Person(name));
        // PRG because this is a POST
        resp.sendRedirect("/jee_orm/list.jsp");
    }

    private void delete(HttpServletRequest req, HttpServletResponse resp) throws IOException {
        PersonDAO dao = Database.INSTANCE.getPersonDAO();
        String id = req.getParameter("id");
        dao.delete(Long.valueOf(id));
        resp.sendRedirect("/jee_orm/list.jsp");
    }

}
