package edu.chl.hajo.shop.core;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

/**
 * A single row in a PurchaseOrder
 *
 * @author hajo
 */
@NoArgsConstructor
@EqualsAndHashCode(of = {"id"})
@Entity    // Else no items in database
public class OrderItem implements Serializable {

    @Getter
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    @Getter
    @ManyToOne
    private Product product;
    @Setter
    @Getter
    private int quantity;

    public OrderItem(Product product, int quantity) {
        this.product = product;
        this.quantity = quantity;
    }
}
