package query.model;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;

/**
 *
 * @author hajo
 */
@EqualsAndHashCode(of = "manufacturerId")
@Entity
@Table(name = "MANUFACTURER")
public class Manufacturer implements Serializable {

    private static final long serialVersionUID = 1L;
    @Getter
    @Setter
    @Id
    @Basic(optional = false)
    @NotNull
    @Column(name = "MANUFACTURER_ID")
    private Integer manufacturerId;
    @Getter
    @Setter
    @Size(max = 30)
    @Column(name = "NAME")
    private String name;
    @Getter
    @Setter
    @Size(max = 30)
    @Column(name = "ADDRESSLINE1")
    private String addressline1;
    @Getter
    @Setter
    @Size(max = 30)
    @Column(name = "ADDRESSLINE2")
    private String addressline2;
    @Getter
    @Setter
    @Size(max = 25)
    @Column(name = "CITY")
    private String city;
    @Getter
    @Setter
    @Size(max = 2)
    @Column(name = "STATE")
    private String state;
    @Getter
    @Setter
    @Size(max = 10)
    @Column(name = "ZIP")
    private String zip;
    @Getter
    @Setter
// @Pattern(regexp="^\\(?(\\d{3})\\)?[- ]?(\\d{3})[- ]?(\\d{4})$", message="Invalid phone/fax format, should be as xxx-xxx-xxxx")//if the field contains phone or fax number consider using this annotation to enforce field validation
    @Size(max = 12)
    @Column(name = "PHONE")
    private String phone;
    // @Pattern(regexp="^\\(?(\\d{3})\\)?[- ]?(\\d{3})[- ]?(\\d{4})$", message="Invalid phone/fax format, should be as xxx-xxx-xxxx")//if the field contains phone or fax number consider using this annotation to enforce field validation
    @Getter
    @Setter
    @Size(max = 12)
    @Column(name = "FAX")
    private String fax;
    @Getter
    @Setter
// @Pattern(regexp="[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?", message="Invalid email")//if the field contains email address consider using this annotation to enforce field validation
    @Size(max = 40)
    @Column(name = "EMAIL")
    private String email;
    @Getter
    @Setter
    @Size(max = 30)
    @Column(name = "REP")
    private String rep;
    @Getter
    @Setter
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "manufacturerId")
    private Collection<Product> productCollection;

    public Manufacturer() {
    }

    public Manufacturer(Integer manufacturerId) {
        this.manufacturerId = manufacturerId;
    }

}
