/*
    Control
*/
var express = require('express');
var Person = require('../models/person.js');

var router = express.Router();

router.get('/', function(req, res, next) {
    // Promised based
    Person.findAll().then(function(persons) {
        //console.log(notes);
        res.render('list', {
            title: 'List',
            persons: persons
        });
    });
});

router.post('/add', function(req, res, next) {
    Person.build({name: req.body.name}).save().then(function() {
        res.redirect("/list");
    }).catch(function(error) {
        console.log(error);
    })
});

router.get('/add', function(req, res, next) {
    res.render('add', {title: 'Add'});
});

router.get('/delete', function(req, res, next) {
    //console.log("Get delete");
    var id = parseInt(req.query.id);
    Person.findById(id).then(function(person) {
        res.render('delete', {
            text: 'Delete',
            person: person
        });
    });
});

router.post('/delete', function(req, res, next) {
    var id = parseInt(req.body.id);
    console.log("Get delete ID: " + id);
    Person.findById(id).then(function(note) {
        return note.destroy();
    }).then(function() {
        res.redirect("/list");
    });
});

router.get('/search/:name', function(req, res, next) {
    var name = req.params.name;
    console.log("Search name: " + name);

    // Alternative to raw queries
    Person.findAll({
        where: {
            name: name
        }
    }).then(function(persons) {
        console.log(persons);
        res.render('list', {
            title: 'List',
            persons: persons
        });
    });
});

module.exports = router;
