
$(function() {
    $("#getPersons").on("click", rest.getPersons);
    $("#getById").on("click", rest.getById);
    $("#add").on("click", rest.add);
    $("#clear").on("click", rest.clear);

});

var rest = (function() {

    var baseURL = 'http://localhost:3000/service/';

    return {
        getPersons: function() {
            console.log("Before ajax get call");
            // Get a deferred object and resolve it (then)
            // Incomming json automagically transformed JS object
            $.get(baseURL).then(function(json) { // Success
                console.log(json);
                $("#personsResult").html(JSON.stringify(json));
            }).fail( // This is jQuery, standard Promise is catch()
                    function(error) { // Error
                $("#error").html(JSON.stringify(error));
            });
            console.log("After ajax get call");
        },
        getById: function() {
            var id = $("#id").val();
            $.get(baseURL + id).then(function(json) { // Success
                console.log(json);
                $("#idResult").html(JSON.stringify(json));
            }).fail( // This is jQuery, standard Promise is catch()
                    function(error) { // Error
                $("#error").html(JSON.stringify(error));
            });
            console.log("After ajax get call");
        },
        add: function() {
            // Get input value
            var name = $("#name").val();
            console.log(name);
            $.post(baseURL, {name: name}).fail(
                    function(error) {
                $("#error").html(JSON.stringify(error));
            });
        },
        clear: function() {
            $(".result").empty();
        }
    }
})();
