package rest.model;

import static java.lang.System.out;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Objects;
import javax.inject.Singleton;

/**
 *
 * @author hajo
 */
@Singleton
public class PersonList {

    private final List<Person> persons = new ArrayList<>();

    public PersonList() {
        // Test data
        persons.add(new Person(1L, "pelle"));
        persons.add(new Person(2L, "olle"));
        persons.add(new Person(3L, "fia"));
    }

    // Tomcat 8 doesn't support Java 8
    public List<Person> getPersons() {
        /*Collections.sort(persons, (n1, n2) -> {
            return n1.getId() < n1.getId() ? -1 : Objects.equals(n1.getId(), n2.getId()) ? 0 : 1;
        });*/
        Collections.sort(persons, new Comparator<Person>() {
            @Override
            public int compare(Person t1, Person t2) {
                return t1.getId() < t2.getId() ? -1
                        : Objects.equals(t1.getId(), t2.getId()) ? 0 : 1;
            }

        });
        System.out.println(persons);
        return persons;
    }

    public Person getById(Long id) {
        /*Optional<Person> n = persons.stream()
                .filter(i -> i.getId().equals(id))
                .findFirst();
        return n.orElse(null);
         */
        for (Person t : persons) {
            if (t.getId().equals(id)) {
                return t;
            }
        }
        return null;
    }

    public void add(Person person) {
        out.println("Add " + person);
        if (!persons.contains(person)) {
            persons.add(person);
        }
    }

    public void update(Person person) {
        out.println("Update " + person);
        // Not implemented
    }

    public Person delete(Long id) {
        Person n = getById(id);
        persons.remove(n);
        return n;
    }

    public int size() {
        return persons.size();
    }

}
