/*
	Person list model object
*/
var Person = require('./person.js');

function PersonList() {
    this.persons = [
        new Person(1, "Olle"),
        new Person(2, "Pelle"),
        new Person(3, "Fia")
    ];
};

PersonList.prototype = (function() {

    // Must supply persons, "this.persons" or "person" doesn't work
    function find(id, persons) {
        var result = persons.filter(function(v) {
            return v.id === id;
        });
        return result[0];
    }

    return {
        getPersons: function() {
            return this.persons;
        },
        getById: function(id) {
            return find(id, this.persons);
        },
        add: function(person) {
            console.log(JSON.stringify(person));
            var found = this.getById(person);
            if (!found) {
                this.persons.push(person);
            }
            console.log(JSON.stringify(this.persons));
        },
        delete: function(id) {
            var person = find(id, this.persons);
            if (person) {
                this.persons.splice(this.persons.indexOf(person), 1);
            }
            return person;
        },
        size: function() {
            return this.persons.length;
        }
    }
})();

module.exports = PersonList;
