var express = require('express');
var Person = require('../models/person.js');
var PersonList = require('../models/personlist.js');

var personList = new PersonList();
var router = express.Router();

router.get('/', function(req, res, next) {
    console.log("GET: getPersons" + JSON.stringify(personList.getPersons()));
    res.json(personList.getPersons());
});

// Must be before GET /:id !!! Matching top down ...!
router.get('/count', function(req, res, next) {
    console.log("GET: count " + personList.size());
    res.json({count: personList.size()});
})

router.get('/:id', function(req, res, next) {
    var id = parseInt(req.params.id);
    console.log("GET: id = " + id);
    var result = personList.getById(id);
    if (!result) {
        res.status(404).send("Not found");
    } else {
        res.json(result);
    }
});

router.post('/', function(req, res, next) {
    console.log("POST: " + req.body.name);
    var person = new Person(null, req.body.name);
    personList.add(person);
    res.status(201).json(person); // Needed for Backbone create()
});

router.delete('/:id', function(req, res, next) {
    var id = parseInt(req.params.id);
    console.log("DELETE: " + id);
    personList.delete(id);
    res.sendStatus(200);
});

router.put('/:id', function(req, res, next) {
    console.log("PUT: " + req.params.id + " : " + req.body.name);
    var id = parseInt(req.params.id);
    var result = personList.getById(id);
    console.log("To be updated: " + JSON.stringify(result));
    if (!result) {
        res.status(404).send("Not found");
    } else {
        // NOT Implemented
        //var person = new Person(result.id, req.body.name);
        //personList.update(person);
        res.sendStatus(200);
    }

});

module.exports = router;
