/*

    This is a **PROXY** for a person list on server side
*/
// Define dependencies
define([
    'underscore', 'backbone', 'models/person'
], function(_, Backbone, Person) { // Inject dependencies (in order)
    'use strict';
    /*
    	All CRUD methods are defined by Backbone (i.e. there are hidden functions)
    	- PersonList.add()
    	- PersonList.remove(id)
    	- PersonList.add(...)
    	- PersonList.length();
    	- etc. see Backbone docs.

    */
    var PersonList = Backbone.Collection.extend({

        // Should specify which model "class" the collection handles
        model: Person,

        url: 'http://localhost:3000/list',

        // Specify wich id to use (not the autogenerated by Backbone = cid)
        modelId: function(attributes) {
            return attributes.id;
        }
    });

    return PersonList;
});
