/*
    Application entry
*/

/*global require*/
'use strict';

// Require.js allows us to configure shortcut alias, see paths
requirejs.config({
    // The shim config allows us to configure dependencies for
    // scripts that do not call define() to register a module
    shim: {
        underscore: {
            exports: '_'
        },
        backbone: {
            deps: [
                'underscore', 'jquery'
            ],
            exports: 'Backbone'
        },
        backboneLocalstorage: {
            deps: ['backbone'],
            exports: 'Store'
        }
    },
    paths: {
        jquery: '../node_modules/jquery/dist/jquery',
        underscore: '../node_modules/underscore/underscore',
        backbone: '../node_modules/backbone/backbone',
        backboneLocalstorage: '../node_modules/backbone.localstorage/backbone.localStorage',
        text: '../node_modules/requirejs-text/text',
        mustache: '../node_modules/mustache/mustache'
    }
});

/*
    Create the App
*/
require([
    'backbone', 'collections/personList', 'views/appView'

], function(Backbone, PersonList, AppView) {
    var personList = new PersonList();
    // Create the application view, supply collection
    new AppView(personList);

});
