/*
	Person list model object
*/
define([
    '../service/personservice', 'models/person'
], function(service, Person) {
    'use strict';

    return {
        // Doing conversion from json to Persons
        getPersons: function(callback) {
            service.getPersons().done(function(json) {
                //console.log("getPersons DONE");
                var persons = [];
                json.forEach(function(i) {
                    persons.push(new Person(i.id, i.name));
                });
                callback(persons);
            }).fail(function() {
                console.log("getPersons failed");
            })
        },
        getById: function(id, callback) {
            service.find(id).done(function() {}).fail(function() {
                console.log("getById failed");
            })
        },
        add: function(person) {
            return service.add(person);
        },
        delete: function(id, callback) {
            service.delete(id).done(function() {
                callback();
            }).fail(function() {
                console.log("delete failed");
            })
        }
    }
})
