package primepush;

/**
 *
 * @author hajo
 */
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.enterprise.context.RequestScoped;
import javax.faces.application.FacesMessage;
import javax.inject.Named;
import org.apache.commons.lang.StringEscapeUtils;
import org.primefaces.push.EventBus;
import org.primefaces.push.EventBusFactory;

@Named 
@RequestScoped
public class NotifyView {
    private static final Logger LOG = Logger.getLogger(NotifyView.class.getSimpleName());

    private final static String CHANNEL = "/notify";

    private String summary;

    private String detail;

    public String getSummary() {
        return summary;
    }

    public void setSummary(String summary) {
        this.summary = summary;
    }

    public String getDetail() {
        return detail;
    }

    public void setDetail(String detail) {
        this.detail = detail;
    }

    /*
    publish(Object o): Fires given object to all connected RemoteEndPoints.
    
    publish(String path, Object o): Fires given object to RemoteEndPoints that connected to the path.
    
    publish(String path, Object o, Reply reply): Fires given object to RemoteEndPoints that
    connected to the path by passing a Reply instance. Reply is an interface with a callback called
    completed(String path) that is invoked when the EventBus delivered the message to the
    PushEndPoint that matches the path used to initiate the publish operation.
    */
    public void send() {
        LOG.log(Level.INFO, "*** Send {0} {1}", new Object[]{summary, detail});
        EventBus eventBus = EventBusFactory.getDefault().eventBus();
        eventBus.publish(CHANNEL, new FacesMessage(StringEscapeUtils.escapeHtml(summary), 
                StringEscapeUtils.escapeHtml(detail)));
    }
}
