package edu.chl.hajo.shop.util;

import java.io.Serializable;

/**
 * Contract for entity classes. 
 * All entity classes must have a unique id
 * (later id will be auto generated by database)
 * Also they all must be serializable
 * 
 * K is type of id (primary key)
 * 
 * @author hajo
 * @param <K> type for key (later primary key)
 */
public interface IEntity<K> extends Serializable  {
    public K getId();
}
